SETREGID(2)

NAME
setregid - set real and effective group IDs

SYNOPSIS
#include <unistd.h>
int
setregid(gid_t rgid, gid_t egid);

DESCRIPTION
The real and effective group IDs of the current process are set according to the arguments. The saved group ID will be set to the new value of the real group ID if a real group ID is specified and either the new real group ID value is different from the current value or the new value of the effective group ID differs from the current saved group ID.

Unprivileged users may change either group ID to the current value of the real, effective, or saved group ID. Only the superuser may make other changes.

Supplying a value of -1 for either the real or effective group ID forces the system to substitute the current ID in place of the -1 parameter.

The setregid() function was intended to allow swapping the real and effective group IDs in set-group-ID programs to temporarily relinquish the set-group-ID value. This purpose is now better served by the use of the setegid(2) function.

When setting the real and effective group IDs to the same value, the setgid(2) function is preferred.

RETURN VALUES

ERRORS

[EPERM]
    The current process is not the superuser and a change other than changing the effective group ID to the real group ID was specified.

SEE ALSO
getgid(2), setegid(2), setgid(2), setresgid(2), setreuid(2)

STANDARDS
The setregid() function conforms to the p1003.1-2008 specification, except that the conditions for changing the saved group ID differ and that, if it is changed, the saved group ID is set to the real group ID instead of the effective group ID.

HISTORY
The setregid() system call first appeared in 4.1cBSD, predating POSIX. A semantically different version appeared in 4.4BSD. The current version, with the original semantics restored, appeared in OpenBSD 3.3.